import java.util.Collection;

import javax.persistence.EntityManager;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(String name, long salary) {
    Professor emp = new Professor();
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }


  public Project createProject(String name) {
    Project space = new Project();
    space.setName(name);
    em.persist(space);

    return space;
  }


  public Collection<Professor> findAllProfessors() {
    return (Collection<Professor>) em.createQuery("SELECT e FROM Professor e").getResultList();
  }

  public void assignProfessorToProject(int empId, int projectId) {
    Project project = em.find(Project.class, projectId);
    Professor employee = em.find(Professor.class, empId);
    project.getProfessors().add(employee);
    employee.getProjects().add(project);
  }

  public Collection<Project> findAllProjects() {
    return (Collection<Project>) em.createQuery("SELECT p FROM Project p").getResultList();
  }
}
